package com.hai.dao;

import com.hai.entity.ApiBlxCoupon;
import com.hai.entity.ApiBlxCouponExample.Criteria;
import com.hai.entity.ApiBlxCouponExample.Criterion;
import com.hai.entity.ApiBlxCouponExample;
import java.util.List;
import java.util.Map;
import org.apache.ibatis.jdbc.SQL;

public class ApiBlxCouponSqlProvider {

    public String countByExample(ApiBlxCouponExample example) {
        SQL sql = new SQL();
        sql.SELECT("count(*)").FROM("api_blx_coupon");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String deleteByExample(ApiBlxCouponExample example) {
        SQL sql = new SQL();
        sql.DELETE_FROM("api_blx_coupon");
        applyWhere(sql, example, false);
        return sql.toString();
    }

    public String insertSelective(ApiBlxCoupon record) {
        SQL sql = new SQL();
        sql.INSERT_INTO("api_blx_coupon");
        
        if (record.getCouponCode() != null) {
            sql.VALUES("coupon_code", "#{couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.VALUES("coupon_name", "#{couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiveType() != null) {
            sql.VALUES("receive_type", "#{receiveType,jdbcType=INTEGER}");
        }
        
        if (record.getUseStartTime() != null) {
            sql.VALUES("use_start_time", "#{useStartTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUseEndTime() != null) {
            sql.VALUES("use_end_time", "#{useEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDenomination() != null) {
            sql.VALUES("denomination", "#{denomination,jdbcType=INTEGER}");
        }
        
        if (record.getMinPrice() != null) {
            sql.VALUES("min_price", "#{minPrice,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveLimit() != null) {
            sql.VALUES("receive_limit", "#{receiveLimit,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveDays() != null) {
            sql.VALUES("receive_days", "#{receiveDays,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.VALUES("create_time", "#{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.VALUES("update_time", "#{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCouponStatus() != null) {
            sql.VALUES("coupon_status", "#{couponStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.VALUES("ext_1", "#{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.VALUES("ext_2", "#{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.VALUES("ext_3", "#{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.VALUES("ext_4", "#{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.VALUES("ext_5", "#{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.VALUES("ext_6", "#{ext6,jdbcType=VARCHAR}");
        }
        
        return sql.toString();
    }

    public String selectByExample(ApiBlxCouponExample example) {
        SQL sql = new SQL();
        if (example != null && example.isDistinct()) {
            sql.SELECT_DISTINCT("id");
        } else {
            sql.SELECT("id");
        }
        sql.SELECT("coupon_code");
        sql.SELECT("coupon_name");
        sql.SELECT("receive_type");
        sql.SELECT("use_start_time");
        sql.SELECT("use_end_time");
        sql.SELECT("denomination");
        sql.SELECT("min_price");
        sql.SELECT("receive_limit");
        sql.SELECT("receive_days");
        sql.SELECT("create_time");
        sql.SELECT("update_time");
        sql.SELECT("coupon_status");
        sql.SELECT("ext_1");
        sql.SELECT("ext_2");
        sql.SELECT("ext_3");
        sql.SELECT("ext_4");
        sql.SELECT("ext_5");
        sql.SELECT("ext_6");
        sql.FROM("api_blx_coupon");
        applyWhere(sql, example, false);
        
        if (example != null && example.getOrderByClause() != null) {
            sql.ORDER_BY(example.getOrderByClause());
        }
        
        return sql.toString();
    }

    public String updateByExampleSelective(Map<String, Object> parameter) {
        ApiBlxCoupon record = (ApiBlxCoupon) parameter.get("record");
        ApiBlxCouponExample example = (ApiBlxCouponExample) parameter.get("example");
        
        SQL sql = new SQL();
        sql.UPDATE("api_blx_coupon");
        
        if (record.getId() != null) {
            sql.SET("id = #{record.id,jdbcType=BIGINT}");
        }
        
        if (record.getCouponCode() != null) {
            sql.SET("coupon_code = #{record.couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.SET("coupon_name = #{record.couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiveType() != null) {
            sql.SET("receive_type = #{record.receiveType,jdbcType=INTEGER}");
        }
        
        if (record.getUseStartTime() != null) {
            sql.SET("use_start_time = #{record.useStartTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUseEndTime() != null) {
            sql.SET("use_end_time = #{record.useEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDenomination() != null) {
            sql.SET("denomination = #{record.denomination,jdbcType=INTEGER}");
        }
        
        if (record.getMinPrice() != null) {
            sql.SET("min_price = #{record.minPrice,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveLimit() != null) {
            sql.SET("receive_limit = #{record.receiveLimit,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveDays() != null) {
            sql.SET("receive_days = #{record.receiveDays,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCouponStatus() != null) {
            sql.SET("coupon_status = #{record.couponStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        }
        
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByExample(Map<String, Object> parameter) {
        SQL sql = new SQL();
        sql.UPDATE("api_blx_coupon");
        
        sql.SET("id = #{record.id,jdbcType=BIGINT}");
        sql.SET("coupon_code = #{record.couponCode,jdbcType=VARCHAR}");
        sql.SET("coupon_name = #{record.couponName,jdbcType=VARCHAR}");
        sql.SET("receive_type = #{record.receiveType,jdbcType=INTEGER}");
        sql.SET("use_start_time = #{record.useStartTime,jdbcType=TIMESTAMP}");
        sql.SET("use_end_time = #{record.useEndTime,jdbcType=TIMESTAMP}");
        sql.SET("denomination = #{record.denomination,jdbcType=INTEGER}");
        sql.SET("min_price = #{record.minPrice,jdbcType=INTEGER}");
        sql.SET("receive_limit = #{record.receiveLimit,jdbcType=INTEGER}");
        sql.SET("receive_days = #{record.receiveDays,jdbcType=INTEGER}");
        sql.SET("create_time = #{record.createTime,jdbcType=TIMESTAMP}");
        sql.SET("update_time = #{record.updateTime,jdbcType=TIMESTAMP}");
        sql.SET("coupon_status = #{record.couponStatus,jdbcType=INTEGER}");
        sql.SET("ext_1 = #{record.ext1,jdbcType=VARCHAR}");
        sql.SET("ext_2 = #{record.ext2,jdbcType=VARCHAR}");
        sql.SET("ext_3 = #{record.ext3,jdbcType=VARCHAR}");
        sql.SET("ext_4 = #{record.ext4,jdbcType=VARCHAR}");
        sql.SET("ext_5 = #{record.ext5,jdbcType=VARCHAR}");
        sql.SET("ext_6 = #{record.ext6,jdbcType=VARCHAR}");
        
        ApiBlxCouponExample example = (ApiBlxCouponExample) parameter.get("example");
        applyWhere(sql, example, true);
        return sql.toString();
    }

    public String updateByPrimaryKeySelective(ApiBlxCoupon record) {
        SQL sql = new SQL();
        sql.UPDATE("api_blx_coupon");
        
        if (record.getCouponCode() != null) {
            sql.SET("coupon_code = #{couponCode,jdbcType=VARCHAR}");
        }
        
        if (record.getCouponName() != null) {
            sql.SET("coupon_name = #{couponName,jdbcType=VARCHAR}");
        }
        
        if (record.getReceiveType() != null) {
            sql.SET("receive_type = #{receiveType,jdbcType=INTEGER}");
        }
        
        if (record.getUseStartTime() != null) {
            sql.SET("use_start_time = #{useStartTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUseEndTime() != null) {
            sql.SET("use_end_time = #{useEndTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getDenomination() != null) {
            sql.SET("denomination = #{denomination,jdbcType=INTEGER}");
        }
        
        if (record.getMinPrice() != null) {
            sql.SET("min_price = #{minPrice,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveLimit() != null) {
            sql.SET("receive_limit = #{receiveLimit,jdbcType=INTEGER}");
        }
        
        if (record.getReceiveDays() != null) {
            sql.SET("receive_days = #{receiveDays,jdbcType=INTEGER}");
        }
        
        if (record.getCreateTime() != null) {
            sql.SET("create_time = #{createTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getUpdateTime() != null) {
            sql.SET("update_time = #{updateTime,jdbcType=TIMESTAMP}");
        }
        
        if (record.getCouponStatus() != null) {
            sql.SET("coupon_status = #{couponStatus,jdbcType=INTEGER}");
        }
        
        if (record.getExt1() != null) {
            sql.SET("ext_1 = #{ext1,jdbcType=VARCHAR}");
        }
        
        if (record.getExt2() != null) {
            sql.SET("ext_2 = #{ext2,jdbcType=VARCHAR}");
        }
        
        if (record.getExt3() != null) {
            sql.SET("ext_3 = #{ext3,jdbcType=VARCHAR}");
        }
        
        if (record.getExt4() != null) {
            sql.SET("ext_4 = #{ext4,jdbcType=VARCHAR}");
        }
        
        if (record.getExt5() != null) {
            sql.SET("ext_5 = #{ext5,jdbcType=VARCHAR}");
        }
        
        if (record.getExt6() != null) {
            sql.SET("ext_6 = #{ext6,jdbcType=VARCHAR}");
        }
        
        sql.WHERE("id = #{id,jdbcType=BIGINT}");
        
        return sql.toString();
    }

    protected void applyWhere(SQL sql, ApiBlxCouponExample example, boolean includeExamplePhrase) {
        if (example == null) {
            return;
        }
        
        String parmPhrase1;
        String parmPhrase1_th;
        String parmPhrase2;
        String parmPhrase2_th;
        String parmPhrase3;
        String parmPhrase3_th;
        if (includeExamplePhrase) {
            parmPhrase1 = "%s #{example.oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{example.oredCriteria[%d].allCriteria[%d].value} and #{example.oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{example.oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{example.oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{example.oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{example.oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        } else {
            parmPhrase1 = "%s #{oredCriteria[%d].allCriteria[%d].value}";
            parmPhrase1_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s}";
            parmPhrase2 = "%s #{oredCriteria[%d].allCriteria[%d].value} and #{oredCriteria[%d].criteria[%d].secondValue}";
            parmPhrase2_th = "%s #{oredCriteria[%d].allCriteria[%d].value,typeHandler=%s} and #{oredCriteria[%d].criteria[%d].secondValue,typeHandler=%s}";
            parmPhrase3 = "#{oredCriteria[%d].allCriteria[%d].value[%d]}";
            parmPhrase3_th = "#{oredCriteria[%d].allCriteria[%d].value[%d],typeHandler=%s}";
        }
        
        StringBuilder sb = new StringBuilder();
        List<Criteria> oredCriteria = example.getOredCriteria();
        boolean firstCriteria = true;
        for (int i = 0; i < oredCriteria.size(); i++) {
            Criteria criteria = oredCriteria.get(i);
            if (criteria.isValid()) {
                if (firstCriteria) {
                    firstCriteria = false;
                } else {
                    sb.append(" or ");
                }
                
                sb.append('(');
                List<Criterion> criterions = criteria.getAllCriteria();
                boolean firstCriterion = true;
                for (int j = 0; j < criterions.size(); j++) {
                    Criterion criterion = criterions.get(j);
                    if (firstCriterion) {
                        firstCriterion = false;
                    } else {
                        sb.append(" and ");
                    }
                    
                    if (criterion.isNoValue()) {
                        sb.append(criterion.getCondition());
                    } else if (criterion.isSingleValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase1, criterion.getCondition(), i, j));
                        } else {
                            sb.append(String.format(parmPhrase1_th, criterion.getCondition(), i, j,criterion.getTypeHandler()));
                        }
                    } else if (criterion.isBetweenValue()) {
                        if (criterion.getTypeHandler() == null) {
                            sb.append(String.format(parmPhrase2, criterion.getCondition(), i, j, i, j));
                        } else {
                            sb.append(String.format(parmPhrase2_th, criterion.getCondition(), i, j, criterion.getTypeHandler(), i, j, criterion.getTypeHandler()));
                        }
                    } else if (criterion.isListValue()) {
                        sb.append(criterion.getCondition());
                        sb.append(" (");
                        List<?> listItems = (List<?>) criterion.getValue();
                        boolean comma = false;
                        for (int k = 0; k < listItems.size(); k++) {
                            if (comma) {
                                sb.append(", ");
                            } else {
                                comma = true;
                            }
                            if (criterion.getTypeHandler() == null) {
                                sb.append(String.format(parmPhrase3, i, j, k));
                            } else {
                                sb.append(String.format(parmPhrase3_th, i, j, k, criterion.getTypeHandler()));
                            }
                        }
                        sb.append(')');
                    }
                }
                sb.append(')');
            }
        }
        
        if (sb.length() > 0) {
            sql.WHERE(sb.toString());
        }
    }
}